It is grml-debootstrap (>= 0.7) and not 0.8
[grml-autoconfig.git] / autoconfig.functions
index cb9b1df..7960772 100755 (executable)
@@ -4,7 +4,7 @@
 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
-# Latest change: Son Mär 25 12:32:37 CEST 2007 [mika]
+# Latest change: Mon Apr 16 19:32:25 CEST 2007 [mika]
 ################################################################################
 
 # {{{ path, variables, signals, umask, zsh
@@ -270,39 +270,43 @@ config_language(){
 
  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
 
-  # Set default keyboard before interactive setup
-  if [ -n "$KEYTABLE" ] ; then
-   einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
-   loadkeys -q $KEYTABLE &
-   eend $?
-  fi
-
-  if [ -n "$CONSOLEFONT" ] ; then
-     einfo "Running consolechars using ${CONSOLEFONT}"
-     consolechars -f $CONSOLEFONT || consolechars -d
-     eend $?
-  fi
+ # activate unicode console if running within utf8 environment
+ if [ -r /etc/default/locale ] ; then
+    if grep -q "LANG=.*UTF" /etc/default/locale ; then
+       if checkgrmlsmall && [ -z "$INSTALLED" ] ; then
+          ewarn "Not runnning unicode_start: grml-small with reduced language support detected." ; eend 0
+       else
+          einfo "Setting up unicode environment."
+          unicode_start 2>>$DEBUG ; eend $?
+       fi
+    fi
+ fi
 
-  # we have to set up all consoles, therefore loop it over all ttys:
-  if [ -n "$CHARMAP" ] ; then
-     einfo "Running consolechars for ${CHARMAP}"
-     NUM_CONSOLES=`fgconsole --next-available`
-     NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
-     [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
-     for vc in `seq 0 ${NUM_CONSOLES}`  ; do
-       consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
-     done
-     eend ${RC}
-  fi
+ # Set default keyboard before interactive setup
+ if [ -n "$KEYTABLE" ] ; then
+  einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
+  loadkeys -q $KEYTABLE &
+  eend $?
+ fi
 
-  # activate unicode console if running within utf8 environment
-  if [ -r /etc/default/locale ] ; then
-     if grep -q "LANG=.*UTF" /etc/default/locale ; then
-        einfo "Setting up unicode environment."
-        unicode_start
-        eend $?
-     fi
-  fi
+ # we have to set up all consoles, therefore loop it over all ttys:
+ NUM_CONSOLES=`fgconsole --next-available`
+ NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
+ [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
+ if [ -n "$CHARMAP" ] ; then
+    einfo "Running consolechars for ${CHARMAP}"
+    for vc in `seq 0 ${NUM_CONSOLES}`  ; do
+        consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
+    done
+    eend $RC
+ fi
+ if [ -n "$CONSOLEFONT" ] ; then
+    einfo "Running consolechars using ${CONSOLEFONT}"
+    for vc in `seq 0 ${NUM_CONSOLES}`  ; do
+        consolechars --tty=/dev/tty${vc} -f $CONSOLEFONT || consolechars --tty=/dev/tty${vc} -d
+    done
+    eend $?
+ fi
 
  eoutdent
 }
@@ -344,7 +348,7 @@ config_time(){
     # hwclock uses the TZ variable
     [ -r /etc/timezone ] && TZ=$(cat /etc/timezone)
     [ -n "$TZ" ] || TZ=Europe/Vienna
-  
+
     if ! [ -r /dev/rtc ] ; then
       ewarn "Realtime clock not available, skipping execution of hwclock therefore." ; eend 0
     else
@@ -364,7 +368,7 @@ config_time(){
 
 # {{{ print kernel info
 config_kernel(){
-  vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMWare${NORMAL}"
+  vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
   if [ -r /proc/cpuinfo ] ; then
@@ -385,16 +389,29 @@ config_kernel(){
 # {{{ vmware specific stuff
 config_vmware(){
 if checkbootparam novmware ; then
- ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
  ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
 else
- if [ -z "$INSTALLED" ]; then
-  if vmware-detect ; then
-    if [ -r /etc/X11/xorg.conf.vmware ] ; then
-      einfo "Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
-      cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
-    fi
-  fi
- fi
+   if [ -z "$INSTALLED" ] ; then
+      if vmware-detect || stringinstring "BOOT_IMAGE=vmware " "$CMDLINE" ; then
+              if ! checkbootparam qemu ; then
+            if [ -r /etc/X11/xorg.conf.vmware ] ; then
+               einfo "VMware: Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
+               cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
+            fi
+         fi
+      fi
+   fi
+fi
+}
+# }}}
+
+# {{{ qemu specific stuff
+config_qemu(){
+if checkbootparam qemu ; then
+   if [ -r /etc/X11/xorg.conf.example ] ; then
+      einfo "Qemu: Copying /etc/X11/xorg.conf.example to /etc/X11/xorg.conf"
+      cp /etc/X11/xorg.conf.example /etc/X11/xorg.conf ; eend $?
+   fi
 fi
 }
 # }}}
@@ -496,10 +513,21 @@ fi
 # activate serial console {{{
 config_console(){
 if checkbootparam "console"; then
-  einfo "Bootoption (for serial) console detected. Activating mgetty."
+  einfo "Bootoption (for serial) console detected."
+  eindent
+    if [ -r /etc/mgetty/mgetty.config ] ; then
+       MODE=$(getbootparam console | awk -F, '{print $2}')
+       MODE=${MODE%%n*}
+       [ -n "$MODE" ] || MODE=9600 # default mode
+       einfo "Setting speed in /etc/mgetty/mgetty.config to $MODE bps"
+       sed -i "s/speed [0-9]*/speed $MODE/" /etc/mgetty/mgetty.config ; eend $?
+    fi
+
+    einfo "Activating mgetty."
     sed -i 's/^#T0/T0/' /etc/inittab
     sed -i 's/^#T1/T1/' /etc/inittab
-  /sbin/telinit q ; eend $?
+    /sbin/telinit q ; eend $?
+  eoutdent
 fi
 }
 # }}}
@@ -968,118 +996,117 @@ config_fstab(){
 NOSWAP="yes" # we do not use swap by default!
 if checkbootparam "swap" -o checkbootparam "anyswap" ; then
    NOSWAP=''
+   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
 fi
 
 if checkbootparam "nofstab" -o checkbootparam "forensic" ; then
   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
 else
-  checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
   iszsh && setopt nonomatch
   if [ -x /usr/sbin/rebuildfstab ] ; then
-    config_userfstab || fstabuser=grml
-    /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
+     config_userfstab || fstabuser=grml
+     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
   else
-    ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
-  fi
-  if [ -e /var/run/rebuildfstab.pid ]; then
-    # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
-    sleep 8
-  fi
-fi
-# Scan for swap, config, homedir
-if [ -z "$NOSWAP" ]; then
-   einfo "Searching for swap partition(s) as requested."
-fi
-GRML_IMG=""
-GRML_SWP=""
-HOMEDIR="$(getbootparam home)"
-if [ -n "$partitions" ]; then
- while read p m f relax; do
-  case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
-  partoptions="users,exec"
-  fnew=""
-  case "$f" in swap)
-   eindent
-   if [ -n "$NOSWAP" ]; then
-      if [ -z "$INSTALLED" ] ; then
-         ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)" ; eend 0
-      fi
-   else
-     case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
-             S1SUSP|S2SUSP|pmdisk|[zZ]*)
-                if [ -n "$ANYSWAP" ] ; then
-                  einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
-                  swapon $p 2>>$DEBUG ; eend $?
-                else
-                  ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
-                fi
-               ;;
-             *)
-                if [[ "$p" == LABEL* ]] ; then
-                   p=$(blkid -t $p | awk -F: '{print $1}')
-                fi
-                if grep -q $p /proc/swaps ; then
-                   ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
-                else
-                   einfo "Using swap partition ${WHITE}${p}${NORMAL}."
-                   swapon $p 2>>$DEBUG ; eend $?
-                fi
-               ;;
-     esac
-   fi
-   eoutdent
-   continue
-   ;;
-  esac
-# Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
-# Notice: grml-rebuildfstab >= 0.3-1 handles this now
-#  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
-#  [ -d "$m" ] || mkdir -p "$m"
-# WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
-  [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
-  MOUNTOPTS="ro"
-  case "$f" in
-    vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
-    ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
-    *) continue ;;
-    # *) NONEFOUND='1'; continue ;;
-  esac
-  if [ -z "$NOSWAP" ] ; then
-     mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
-     # Activate swapfile, if exists
-     SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
+     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
   fi
-  if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
-   mount -o remount,rw $m
-   if swapon "$SWAPFILE" 2>>$DEBUG ; then
-    einfo "Using GRML swapfile ${SWAPFILE}."
-    fnew="$SWAPFILE swap swap defaults 0 0"
-    stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
-    GRML_SWP="$GRML_SWP $SWAPFILE"
-    eend 0
-   fi
-   mount -o remount,ro $m 2>>$DEBUG
-  fi
-  IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
-  if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
-   if [ -n "$HOMEDIR" ]; then
-    if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
-     continue
-    fi
-   fi
-   if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
-    GRML_IMG="$IMAGE"
-    mount -o remount,ro $m 2>>$DEBUG
-   fi
-  fi
-  eend 0
-  # Umount, if not in use
-  umount -r $m 2>/dev/null
- done <<EOT
-$(cat /etc/fstab)
+fi # checkbootparam nofstab/forensic
+
+# Scan for swap, config, homedir - but only in live-mode
+if [ -z "$INSTALLED" ] ; then
+   [ -z "$NOSWAP" ] && einfo "Searching for swap partition(s) as requested."
+   GRML_IMG=""
+   GRML_SWP=""
+   HOMEDIR="$(getbootparam home)"
+   if [ -n "$partitions" ]; then
+      while read p m f relax; do
+        case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
+        partoptions="users,exec"
+        fnew=""
+        # it's a swap partition?
+        case "$f" in swap)
+          eindent
+          if [ -n "$NOSWAP" ]; then
+             ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)"
+             eend 0
+          else
+             case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
+                   S1SUSP|S2SUSP|pmdisk|[zZ]*)
+                     if [ -n "$ANYSWAP" ] ; then
+                        einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
+                        swapon $p 2>>$DEBUG ; eend $?
+                     else
+                        ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
+                     fi
+                     ;;
+                   *)
+                     if [[ "$p" == LABEL* ]] ; then
+                        p=$(blkid -t $p | awk -F: '{print $1}')
+                     fi
+                     if grep -q $p /proc/swaps ; then
+                        ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
+                     else
+                        einfo "Using swap partition ${WHITE}${p}${NORMAL}."
+                        swapon $p 2>>$DEBUG ; eend $?
+                     fi
+                     ;;
+             esac # dd-check
+          fi # -n "$NOSWAP
+          eoutdent
+          continue
+          ;;
+        esac # it's a swap partition?
+
+        # mount read-only
+        MOUNTOPTS="ro"
+        case "$f" in
+          vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
+          ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
+          *) continue ;;
+          # *) NONEFOUND='1'; continue ;;
+        esac
+
+        # use a swapfile
+        if [ -z "$NOSWAP" ] ; then
+           mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
+           # Activate swapfile, if exists
+           SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
+        fi
+        if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
+           mount -o remount,rw $m && MOUNTED=1
+           if swapon "$SWAPFILE" 2>>$DEBUG ; then
+              einfo "Using GRML swapfile ${SWAPFILE}."
+              fnew="$SWAPFILE swap swap defaults 0 0"
+              stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
+              GRML_SWP="$GRML_SWP $SWAPFILE"
+              eend 0
+           fi
+           mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
+        fi
+
+        # use a image as home
+        IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
+        if [ -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
+           if [ -n "$HOMEDIR" ]; then
+              if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
+                 continue
+              fi
+           fi
+           if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
+              GRML_IMG="$IMAGE"
+              mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
+           fi
+        fi
+        eend 0
+
+        # Umount, if not in use
+        [ -n "$MOUNTED" ] && umount -r $m 2>/dev/null
+
+      done <<EOT
+      $(cat /etc/fstab)
 EOT
-fi
+   fi # -n $partitions
+fi # -z $INSTALLED
 }
 # }}}
 
@@ -1198,58 +1225,49 @@ config_cpu(){
 if checkbootparam "nocpu"; then
   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
 else
-  if ! [ -x /etc/init.d/powernowd ] ; then
-    ewarn "Skipping CPU detection as powernowd dependencies are not fulfilled." ; eend 1
-  elif [ ! -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] ; then
-    ewarn "Skipping CPU detection as module dependencies are not fulfilled." ; eend 1
-  else
-    if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
-      einfo "Detecting CPU:"
-      CPU=$(awk -F: '/^processor/{printf "     Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
-      echo $CPU | sed 's/ \{1,\}/ /g'
-      eend 0
-    else
-      einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
-    fi
-    if /usr/sbin/laptop-detect ; then
-    einfo "Detected Laptop - trying to use cpu frequency scaling:"
-#      loadcpumod() {
-#      for module in /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq/*.ko /lib/modules/${KERNEL}/kernel/drivers/cpufreq/*.ko ; do
-#    # modprobe ${${${${(f)"$(_call_program modules ${(M)words[1]##*/}modprobe -l | grep cpufreq 2>>$DEBUG)"}:#}##*/}%.*}
-#        modprobe `basename ${module%%\.ko}` 1>>$DEBUG 2>&1
-#      done
-#      }
-#    CPU=$(grep 'model name' /proc/cpuinfo | cut -b14- | head -1)
-#    eindent
-#    if [[ $CPU = *Intel* ]] ; then
-#      einfo "Detected CPU is of type Intel - loading modules and starting cpudyn."
-#      local DETECTED=1
-#      loadcpumod
-#      /etc/init.d/cpudyn start 1>>$DEBUG ; eend $?
-#    fi
-#    if [[ $CPU = *AMD* ]] ; then
-#      einfo "Detected CPU is of type AMD - loading modules and starting powernowd."
-#      local DETECTED=1
-#      loadcpumod
-#      /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
-#    fi
-
-     eindent
-     if [ -r /usr/bin/cpufreq-detect.sh ] ; then
-       . /usr/bin/cpufreq-detect.sh
-       if [ -n "$MODULE" -a "$MODULE" != none ]; then
-         einfo "Loading module ${MODULE} and starting powernowd."
-         modprobe cpufreq_userspace 1>>$DEBUG
-         modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
-         /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
-       else
-         ewarn "Could not detect an appropriate CPU for use with powernowd - skipping." && eend 1
-       fi
-     fi
-     eoutdent
+  # check module dependencies
+  cpufreq_check() {
+   if [ -e /lib64 ] ; then
+      [ -e /lib/modules/${KERNEL}/kernel/arch/x86_64/kernel/cpufreq ] || return 1
+   else
+      [ -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] || return 1
    fi
+  }
+
+  if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
+     einfo "Detecting CPU:"
+     CPU=$(awk -F: '/^processor/{printf "      Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
+     echo $CPU | sed 's/ \{1,\}/ /g'
+     eend 0
+  else
+     einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
   fi
-fi
+
+  if ! cpufreq_check ; then
+    ewarn "Skipping cpufreq setup as module dependencies are not fulfilled." ; eend 1
+  else
+    if /usr/sbin/laptop-detect ; then
+       einfo "Detected Laptop - trying to use cpu frequency scaling:"
+       if [ -r /usr/bin/cpufreq-detect.sh ] ; then
+          eindent
+          . /usr/bin/cpufreq-detect.sh
+          if [ -n "$MODULE" -a "$MODULE" != none ]; then
+             einfo "Loading modules ${MODULE} and cpufreq_ondemand, setting ondemand governor"
+             modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
+             if modprobe cpufreq_ondemand && RC=0 || RC=1 ; then
+                for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
+                    echo ondemand > $file
+                done
+             fi
+             eend $RC
+          else
+             ewarn "Could not detect an appropriate CPU for use with cpu frequency scaling - skipping." && eend 1
+          fi
+          eoutdent
+       fi # cpufreq-detect
+    fi # laptop-detect
+  fi # cpufreq_check
+fi # checkbootparam nocpu
 }
 # }}}
 
@@ -1294,79 +1312,83 @@ fi
 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
 config_homedir(){
 if checkbootparam home ; then
-HOMEDIR="$(getbootparam home)"
-MYHOMEDEVICE=""
-MYHOMEMOUNTPOINT=""
-MYHOMEDIR=""
-if [ -n "$HOMEDIR" ]; then
-  einfo "Bootoption home detected." && eend 0
-  case "$HOMEDIR" in
-    /dev/*)
-    MYHOMEDEVICE="${HOMEDIR##/dev/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-    MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
-  ;;
-    /mnt/*)
-    MYHOMEDEVICE="${HOMEDIR##/mnt/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-    MYHOMEDIR="$HOMEDIR"
-  ;;
-    [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
-    MYHOMEDIR="$(findfile grml.img)"
-    MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-  ;;
-  *)
-    eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
-    eerror "Option ignored." ; eend 1
-  ;;
-  esac
-fi
-
-if [ -n "$MYHOMEDIR" ]; then
-  if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
-    [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
-    while read device mountpoint fs relax; do
-      case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
-        case "$fs" in *[Nn][Tt][Ff][Ss]*)
-          umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
-          break
-        ;;
-        *[Ff][Aa][Tt]*)
-        # Note: This currently won't work with encrypted partitions
-        umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
-        if [ ! -f "$MYHOMEDIR" ]; then
-          ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
-          ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
-        fi
-        ;;
-      esac
-      if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
-        einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
-        if [ -f "$MYHOMEDIR" ]; then
-          # It's a loopback file, mount it over the /home/grml directory
-          trymount "$MYHOMEDIR" /home/grml
-          RC="$?"
-          [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
-          RC="$?"
-        else
-          # Do a --bind mount
-          ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
-          RC="$?"
-        fi
-        [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
-      fi
-      break
+   HOMEDIR="$(getbootparam home)"
+   MYHOMEDEVICE=""
+   MYHOMEMOUNTPOINT=""
+   MYHOMEDIR=""
+   if [ -n "$HOMEDIR" ]; then
+      einfo "Bootoption home detected." && eend 0
+      case "$HOMEDIR" in
+        /dev/*)
+        MYHOMEDEVICE="${HOMEDIR##/dev/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
+        MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
+      ;;
+        /mnt/*)
+        MYHOMEDEVICE="${HOMEDIR##/mnt/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
+        MYHOMEDIR="$HOMEDIR"
+      ;;
+        [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
+        MYHOMEDIR="$(findfile grml.img)"
+        MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
+      ;;
+      *)
+        eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
+        eerror "Option ignored." ; eend 1
       ;;
-    esac
-  done <<EOT
-$(cat /proc/mounts)
+      esac
+   fi # -n $HOMEDIR
+
+   if [ -n "$MYHOMEDIR" ]; then
+      if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
+         [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
+         while read device mountpoint fs relax; do
+           case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
+             case "$fs" in
+               *[Nn][Tt][Ff][Ss]*)
+                 umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
+                 break
+                 ;;
+               *[Ff][Aa][Tt]*)
+                 # Note: This currently won't work with encrypted partitions
+                 umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
+                 if [ ! -f "$MYHOMEDIR" ]; then
+                    ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
+                    ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
+                 fi
+                 ;;
+             esac
+
+             if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
+                einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
+                if [ -f "$MYHOMEDIR" ]; then
+                   # It's a loopback file, mount it over the /home/grml directory
+                   trymount "$MYHOMEDIR" /home/grml
+                   RC="$?"
+                   [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
+                   RC="$?"
+                else
+                   # Do a --bind mount
+                   ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
+                   RC="$?"
+                fi # -f $MYHOMEDIR
+
+                [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
+
+             fi #  mount -o remount,rw,...
+           break
+           ;;
+           esac # case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
+         done <<EOT
+         $(cat /proc/mounts)
 EOT
-  fi
-fi
+     fi # if trymount ...
+   fi # -n $MYHOMEDIR
 fi # checkbootparam home
 }
 # }}}
@@ -1634,8 +1656,13 @@ sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
 EOF
    chmod 755 /etc/init.d/xstartup
 
-   sed -i 's#^6:.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#' /etc/inittab
-   
+   # adjust inittab for xstartup
+   if grep -q '^6:' /etc/inittab ; then
+      sed -i 's|^6:.*|6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"|' /etc/inittab
+   else # just append tty6 to inittab if no definition is present:
+      echo '6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"' >> /etc/inittab
+   fi
+
    /sbin/telinit q ; eend $?
 
    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
 # {{{ grml2hd: automatic installation
 config_grml2hd(){
 
+if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
+
 if checkbootparam "user" ; then
-  NEWUSER=''
-  NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
-  sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
+   NEWUSER=''
+   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
+   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
 fi
 
 if checkbootparam "filesystem" ; then
-  FILESYSTEM=''
-  FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
-  sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
+   FILESYSTEM=''
+   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
+   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
+fi
+
+if checkbootparam "partition" ; then
+   PARTITION=''
+   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
+   # notice: the following checks whether the given partition is available, if not the skip
+   # execution of grml2hd as it might result in data loss...
+   if [ -r $PARTITION ] ; then
+      sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
+   else
+      ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
+   fi
+fi
+
+if checkbootparam "mbr" ; then
+   BOOT_PARTITION=''
+   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
+   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
+fi
+
+cat>|/usr/bin/grml2hd_noninteractive<<EOF
+#!/bin/sh
+GRML2HD_NONINTERACTIVE='yes' grml2hd
+EOF
+
+chmod 755 /usr/bin/grml2hd_noninteractive
+einfo "Bootoption grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
+if [ -z "$GRML2HD_FAIL" ] ; then
+   screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
+else
+   ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
+fi
+
+fi # if stringinstring "BOOT_IMAGE=grml2hd ...
+}
+# }}}
+
+# {{{ debootstrap: automatic installation
+config_debootstrap(){
+
+if stringinstring "BOOT_IMAGE=debian2hd " "$CMDLINE" ; then
+
+if ! [ -x /usr/sbin/grml-debootstrap ] ; then
+   eerror "Bootoption debian2hd found, but grml-debootstrap is not available." ; eend 1
+   eerror "Dropping you to a shell, just exit it to continue booting." ; eend 1
+   /bin/zsh
 fi
 
 if checkbootparam "partition" ; then
   PARTITION=''
   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
   # notice: the following checks whether the given partition is available, if not the skip
-  # execution of grml2hd as it might result in data loss...
-  if [ -r $PARTITION ] ; then
-    sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
-  else
-    ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
+  # execution of grml-debootstrap as it might result in data loss...
+  if ! [ -r $PARTITION ] ; then
+     ewarn "Partition $PARTITION does not exist. Skipping execution of grml-debootstrap therefore." ; eend 1
   fi
 fi
 
-if checkbootparam "mbr" ; then
-  BOOT_PARTITION=''
-  BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
-  sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
+if checkbootparam "grub" ; then
+  GRUB=''
+  GRUB="$(getbootparam 'grub' 2>>$DEBUG)"
 fi
 
-if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
-  cat>|/usr/bin/grml2hd_noninteractive<<EOF
+if checkbootparam "groot" ; then
+  GROOT=''
+  GROOT="$(getbootparam 'groot' 2>>$DEBUG)"
+fi
+
+if checkbootparam "release" ; then
+  RELEASE=''
+  RELEASE="$(getbootparam 'release' 2>>$DEBUG)"
+fi
+
+if checkbootparam "mirror" ; then
+  MIRROR=''
+  MIRROR="$(getbootparam 'mirror' 2>>$DEBUG)"
+fi
+
+if checkbootparam "password" ; then
+  PASSWORD=''
+  PASSWORD="$(getbootparam 'password' 2>>$DEBUG)"
+fi
+
+# now check which options are available
+if [ -n "PARTITION" ] ; then
+   PARTITIONCMD="--target $PARTITION"
+else
+   PARTITIONCMD=''
+   ewarn "Partion not set via bootoption. Skipping execution of grml-debootstrap therefore."; eend 1
+fi
+[ -n "$GRUB" ]     && GRUBCMD="--grub $GRUB"               || GRUBCMD=''
+[ -n "$GROOT" ]    && GROOTCMD="--groot $GROOT"            || GROOTCMD=''
+[ -n "$RELEASE" ]  && RELEASECMD="--release $RELEASE"      || RELEASECMD=''
+[ -n "$MIRROR" ]   && MIRRORCMD="--mirror $MIRROR"         || MIRRORCMD=''
+[ -n "$PASSWORD" ] && PASSWORDCMD="--password $PASSWORD" ] || PASSWORDCMD=''
+
+# and finally write script and execute it
+cat>|/usr/bin/grml-debootstrap_noninteractive<<EOF
 #!/bin/sh
-GRML2HD_NONINTERACTIVE='yes' grml2hd
+AUTOINSTALL='yes' grml-debootstrap $PARTITIONCMD $GRUBCMD $GROOTCMD $RELEASECMD $MIRRORCMD $PASSWORDCMD
 EOF
-  chmod 755 /usr/bin/grml2hd_noninteractive
-  einfo "Bootparameter grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
-  if [ -z "$GRML2HD_FAIL" ] ; then
-    screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
-  else
-    ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
+
+chmod 750  /usr/bin/grml-debootstrap_noninteractive
+einfo "Bootoption debian2hd found. Running automatic installation via grml-debootstrap." && eend 0
+
+screen /usr/bin/grml-debootstrap_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
+
+fi # stringinstring "BOOT_IMAGE=debian2hd
+}
+# }}}
+
+# {{{ Support customization
+config_distri(){
+if checkbootparam "distri"; then
+  DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
+  if [ -r /cdrom/desktop/"$DISTRI".jpg ] ; then
+     [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file /cdrom/desktop/$DISTRI present" && eend 0
+     cp /cdrom/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
   fi
 fi
 }